const std = @import("std");
const url = @import("url.zig");
const json = @import("json.zig");

const dbg_print = std.debug.print;
const eql = std.mem.eql;


pub fn main() !void {
    // gpa allocator
    var gpa = std.heap.GeneralPurposeAllocator(.{}){};
    defer _ = gpa.deinit();
    const allocator = gpa.allocator();

    const args = try std.process.argsAlloc(allocator);
    defer std.process.argsFree(allocator, args);
    
    if (args.len > 1) {
        if (eql(u8, args[1], "help")) {
            dbg_print("Help :)\n", .{});
        }
    }

    const data = try url.fetch(allocator, "https://tidal.401658.xyz/track/?id=286266927&quality=LOSSLESS");
    defer allocator.free(data);

    const songData = try json.decode_song_data(allocator, data);

    defer allocator.free(songData.track_url);
    defer allocator.free(songData.track_title);

    try url.download(allocator, songData.track_url, songData.track_title);

}
